<?

// Source by Philipp Lenssen
// licensed under the GNU GPL CC license:
// http://creativecommons.org/licenses/GPL/2.0/

require_once('misc.php5');
require_once('database.php5');
require_once('trivia.php5');

header("Content-type: text/xml; charset=iso-8859-1");
@header( 'Cache-Control: no-cache, must-revalidate'); 

$g_link = openDatabase();
$g_chairs_max = 9;
$g_bubble_max = 9;
$g_avatar_max = 37;
$g_minutes_idle_ok = 45;
$g_suborder = 0;
$g_botName = '';
$g_lastline = '';
$g_roomTitle = '';

$mode = ( isset($_GET['mode']) ) ? $_GET['mode'] : '';
$nick = ( isset($_GET['nick']) ) ? $_GET['nick'] : '';
$avatar = ( isset($_GET['avatar']) ) ? $_GET['avatar'] : 0;
$line = ( isset($_GET['line']) ) ? $_GET['line'] : '';
$fingerprint = ( isset($_GET['fingerprint']) ) ? $_GET['fingerprint'] : '';
$room_tag = ( isset($_GET['room_tag']) ) ? $_GET['room_tag'] : '';
$room_tag = misc_toName($room_tag);

echo '<' . '?xml version="1.0" encoding="UTF-8" ?' . '>';
echo '<chat>';

$room = getRoomFromTag($room_tag);
$g_botName = getBotName($room);

removeDead();
if ( rand(1, 100) == 100 ) {
    removeOldLines();
}

if ($room != 0)
{
    switch ($mode)
    {
        case 'enter':
            handleEnter($nick, $avatar, $room);
            break;
    
        case 'update':
            if ( validateFingerprint($nick, $fingerprint, $room) )
            {
                if ( !removeIdle($nick, $fingerprint, $room) )
                {
                    handleUpdate($nick, $fingerprint, $line, $room);
                    doBreath($nick, $fingerprint, $room);
                }
            }
            else
            {
                echo '<order action="exit" />';
            }
            break;
    
        case 'exit':
            if ( validateFingerprint($nick, $fingerprint, $room) )
            {
                killNick($nick, $fingerprint, $room);
                echo '<status success="1">You left the room.</status>';
            }
            break;
    }
}
else
{
    echo '<status success="0">This room does not exist.</status>';
}

echo '</chat>';

closeDatabase($g_link);


function getRoomFromTag($room_tag)
{
    global $g_roomTitle;

    $room = 0;

    $query = "SELECT id, name FROM chat_room WHERE tag = " . smartQuote($room_tag) . " LIMIT 1";
    $rows = mysql_query($query) or die( "GetRoomFromTag Error: " . mysql_error() );
    while ( $c = mysql_fetch_array($rows) )
    {
        $room = $c['id'];
        $g_roomTitle = $c['name'];
    }

    return $room;
}

function removeOldLines()
{
    global $g_minutes_idle_ok;

    $past = getDateOffset( 60 * ($g_minutes_idle_ok + 2) );
    $query = "DELETE FROM chat_line WHERE timesaid <= " . smartQuote($past);
    $rows = mysql_query($query) or die( "RemoveOldLines Error: " . mysql_error() );
}

function getDateOffset($secondsOff)
{
    return date( "Y-m-d H:i:s", strtotime( getIsoDate() ) - $secondsOff );
}

function removeDead()
{
    $datenow = getIsoDate();
    $query = "SELECT nick, fingerprint, room, lastbreath, bot FROM chat_chair ORDER BY position";
    $rows = mysql_query($query) or die( "RemoveDead Error: " . mysql_error() );
    while ( $c = mysql_fetch_array($rows) )
    {
        if (!$c['bot'])
        {
            $secondsDiff = getSecondsDiff($c['lastbreath'], $datenow);
            if ($secondsDiff >= 60)
            {
                killNick($c['nick'], $c['fingerprint'], $c['room']);
            }
        }
    }
}

function removeIdle($nick, $fingerprint, $room)
{
    global $g_minutes_idle_ok;
    global $g_botName;
    global $g_lastline;

    $didRemove = false;

    $datenow = getIsoDate();
    $query = "SELECT line, timesaid FROM chat_line " .
            "WHERE nick = " . smartQuote($nick) . " AND fingerprint = " . smartQuote($fingerprint) . " AND room = " . smartQuote($room) . " " .
            "ORDER BY timesaid DESC LIMIT 1";

    $rows = mysql_query($query) or die( "RemoveIdle Error: " . mysql_error() );
    while ( $c = mysql_fetch_array($rows) )
    {
        $g_lastline = $c['line'];
        $secondsDiff = getSecondsDiff($c['timesaid'], $datenow);
        if ($secondsDiff >= 60 * $g_minutes_idle_ok)
        {
            killNick($nick, $fingerprint, $room);
            echo '<order action="exit" />';
            $didRemove = true;
            break;
        }
    }

    return $didRemove;
}

function killNick($nick, $fingerprint, $room)
{
    $query = "DELETE FROM chat_chair " .
            "WHERE nick = " . smartQuote($nick) . " AND fingerprint = " . smartQuote($fingerprint) . " AND room = " . smartQuote($room);
    $rows = mysql_query($query) or die( "KillNick Error: " . mysql_error() );
    $query = "DELETE FROM chat_line " .
            "WHERE nick = " . smartQuote($nick) . " AND fingerprint = " . smartQuote($fingerprint) . " AND room = " . smartQuote($room);
    $rows = mysql_query($query) or die( "KillNick2 Error: " . mysql_error() );
}

function doBreath($nick, $fingerprint, $room)
{
    $query = "UPDATE chat_chair SET lastbreath = '" . getIsoDate() . "' " .
            "WHERE nick = " . smartQuote($nick) . " AND fingerprint = " . smartQuote($fingerprint) . " AND room = " . smartQuote($room);
    $rows = mysql_query($query) or die( "DoBreath Error: " . mysql_error() );
}

function getSecondsDiff($datetime1, $datetime2)
{
    $sec1 = strtotime($datetime1);
    $sec2 = strtotime($datetime2);
    return abs($sec1 - $sec2);
}

function handleEnter($nick, $avatar, $room)
{
    global $g_chairs_max;
    global $g_avatar_max;

    if ($avatar >= 1 && $avatar <= $g_avatar_max)
    {
        if ( $nick != '' && isName($nick) )
        {
            if ( nickIsFree($nick, $room) )
            {
                if ( !ipBanned() )
                {
                    $pos = getFreeChair($room);
                    $fingerprint = getNewFingerprint();
    
                    if ($pos != 0)
                    {
                        $pos = sitChair($nick, $pos, $avatar, $fingerprint, $room);
                    }

                    if ($pos != 0)
                    {
                        echo '<status success="1">' . $fingerprint . '</status>';
                    }
                    else
                    {
                        echo '<status success="0">Room full, please try later, or try other room.</status>';
                    }
                }
                else
                {
                    echo '<status success="0">Your computer is currently banned from the room.</status>';
                }
            }
            else
            {
                echo '<status success="0">This nick is taken already.</status>';
            }
        }
        else
        {
            echo '<status success="0">Nick must contain letters and numbers only.</status>';
        }
    }
    else
    {
        echo '<status success="0">This avatar is not available.</status>';
    }
}

function ipBanned()
{
    $ip = getIp();
    return ( strpos($ip, '85.96.') === 0 ||
            strpos($ip, '85.97.') === 0 ||
            strpos($ip, '85.98.') === 0 ||
            strpos($ip, '85.99.') === 0 ||
            strpos($ip, '85.100.') === 0 ||
            strpos($ip, '85.101.') === 0 ||
            strpos($ip, '85.102.') === 0 ||
            strpos($ip, '85.103.') === 0 ||
            strpos($ip, '85.104.') === 0 ||
            strpos($ip, '85.105.') === 0 ||
            strpos($ip, '85.106.') === 0 ||
            strpos($ip, '85.107.') === 0 ||
            strpos($ip, '85.108.') === 0 ||
            strpos($ip, '85.109.') === 0 ||
            strpos($ip, '85.110.') === 0 ||
            strpos($ip, '85.111.') === 0 ||
            strpos($ip, '81.214.') === 0 ||
            strpos($ip, '81.215.') === 0 ||
            strpos($ip, '88.220.') === 0 ||
            strpos($ip, '88.221.') === 0 ||
            strpos($ip, '88.222.') === 0 ||
            strpos($ip, '88.223.') === 0 ||
            strpos($ip, '88.224.') === 0 ||
            strpos($ip, '88.225.') === 0 ||
            strpos($ip, '88.226.') === 0 ||
            strpos($ip, '88.227.') === 0 ||
            strpos($ip, '88.228.') === 0 ||
            strpos($ip, '88.229.') === 0 ||
            strpos($ip, '88.230.') === 0 ||
            strpos($ip, '88.231.') === 0 ||
            strpos($ip, '88.232.') === 0 ||
            strpos($ip, '88.233.') === 0 ||
            strpos($ip, '88.234.') === 0 ||
            strpos($ip, '88.235.') === 0 ||
            strpos($ip, '88.236.') === 0 ||
            strpos($ip, '88.237.') === 0 ||
            strpos($ip, '88.238.') === 0 ||
            strpos($ip, '88.239.') === 0 ||
            strpos($ip, '88.240.') === 0 ||
            strpos($ip, '88.241.') === 0 ||
            strpos($ip, '88.242.') === 0 ||
            strpos($ip, '88.243.') === 0 ||
            strpos($ip, '88.244.') === 0 ||
            strpos($ip, '88.245.') === 0 ||
            strpos($ip, '88.246.') === 0 ||
            strpos($ip, '88.247.') === 0 ||
            strpos($ip, '88.248.') === 0 ||
            strpos($ip, '88.249.') === 0 ||
            strpos($ip, '88.250.') === 0 ||
            strpos($ip, '88.251.') === 0 ||
            strpos($ip, '88.252.') === 0 ||
            strpos($ip, '88.253.') === 0 ||
            strpos($ip, '88.254.') === 0 ||
            strpos($ip, '88.255.') === 0
        );
}

function getIp()
{
    global $_SERVER;
    return $_SERVER['REMOTE_ADDR'];
}

function getFreeChair($room)
{
    $arr_order = array(4, 6, 5, 3, 7, 2, 8, 1, 9);
    $chair_found = 0;
    foreach ($arr_order as $o)
    {
        $query = "SELECT nick FROM chat_chair WHERE position = " . smartQuote($o) . " AND room = " . smartQuote($room);
        $rows = mysql_query($query) or die( "GetFreeChair Error: " . mysql_error() );
        if ( mysql_num_rows($rows) == 0 )
        {
            $chair_found = $o;
            break;
        }
    }

    return $chair_found;
}

function sitChair($nick, $pos, $avatar, $fingerprint, $room)
{
    $datenow = getIsoDate();
    $query = "INSERT INTO chat_chair " .
            "(position, joined, avatar, nick, lastbreath, fingerprint, room, ip)" .
            "VALUES (" . smartQuote($pos) . ", " . smartQuote($datenow) . ", " . smartQuote($avatar) . ", " . smartQuote($nick) . ", " . smartQuote($datenow) . ", " . smartQuote($fingerprint) . ", " . smartQuote($room) . ", " . smartQuote( getIp() ) . ")";
    $rows = mysql_query($query) or die( "SitChair Error: " . mysql_error() ); // clearPos(&$pos)

    return $pos;
}

function clearPos(&$pos)
{
    $pos = 0;
}

function nickIsFree($nick, $room)
{
    $query = "SELECT nick FROM chat_chair WHERE nick = " . smartQuote($nick) . " AND room = " . smartQuote($room);
    $rows = mysql_query($query) or die( "NickIsFree Error: " . mysql_error() );
    return ( mysql_num_rows($rows) == 0 );
}

function getNewFingerprint($size = 15)
{
    $abc = 'abcdefghijklmnopqrstuvwxyz0123456789';
    $s = '';
    for ($i = 0; $i < $size; $i++)
    {
        $pos = rand( 0, strlen($abc) - 2 );
        $s .= substr($abc, $pos, 1);
    }
    return $s;
}

function isName($s)
{
    $isOk = true;
    $s = strtolower($s);
    $abc = 'abcdefghijklmnopqrstuvwxyz0123456789_-~';

    for ($i = 0; $i < strlen($s); $i++)
    {
        $letter = substr($s, $i, 1);
        if ( strpos($abc, $letter) === false )
        {
            $isOk = false;
        }
    }

    return $isOk;
}

function validateFingerprint($nick, $fingerprint, $room)
{
    $query = "SELECT nick FROM chat_chair " .
            "WHERE nick = " . smartQuote($nick) . " AND fingerprint = " . smartQuote($fingerprint) . " AND room = " . smartQuote($room) . " AND bot = 0";
    $rows = mysql_query($query) or die( "ValidateFingerprint Error: " . mysql_error() );

    return ( mysql_num_rows($rows) == 1 );
}

function handleUpdate($nick, $fingerprint, $line, $room)
{
    global $g_chairs_max;
    global $g_bubble_max;
    global $g_botName;
    global $g_lastline;

    if ($line != '')
    {
        if ($line != $g_lastline || $line == '!ask' || $line == '!hint' || $line == '!answer')
        {
            addLine($nick, $fingerprint, $line, $room);
            if ($g_botName != '')
            {
                handleBot($nick, $line, $room);
            }
        }
    }

    $arr_taken = array();
    $arr_nickpos = array();
    for ($i = 1; $i <= $g_chairs_max; $i++)
    {
        $arr_taken[$i] = false;
    }

    $joined = '';

    $query = "SELECT position, joined, avatar, nick FROM chat_chair " .
            "WHERE room = " . smartQuote($room) . " ORDER BY position ASC";
    $rows = mysql_query($query) or die( "HandleUpdate Error: " . mysql_error() );
    while ( $c = mysql_fetch_array($rows) )
    {
        $sYou = '';
        if ($c['nick'] == $nick)
        {
            $joined = $c['joined'];
            $sYou = ' (you)';
        }

        $arr_taken[ $c['position'] ] = true;
        $arr_nickpos[ $c['nick'] ] = $c['position'];
        echo '<chair position="' . $c['position'] . '" avatar="' . $c['avatar'] . '" nick="' . misc_toAttribute($c['nick']) . $sYou . '" />';
    }

    for ($i = 1; $i <= $g_chairs_max; $i++)
    {
        if (!$arr_taken[$i])
        {
            echo '<chair position="' . $i . '" avatar="0" nick="" />';
        }
    }

    $arr_taken_bubble = array();
    for ($i = 1; $i <= $g_bubble_max; $i++)
    {
        $arr_taken_bubble[$i] = false;
    }

    $query = "SELECT nick, fingerprint, line, timesaid FROM chat_line " .
            "WHERE room = " . smartQuote($room) . "AND timesaid >= " . smartQuote($joined) . " " .
            "ORDER BY timesaid DESC, suborder DESC LIMIT 9";
    $rows = mysql_query($query) or die( "HandleUpdate2 Error: " . mysql_error() );
    $bubbleCount = 0;
    while ( $c = mysql_fetch_array($rows) )
    {
        $bubbleN = ($g_bubble_max - $bubbleCount++);
        $arr_taken_bubble[$bubbleN] = true;
        echo '<chatline position="' . misc_toAttribute($arr_nickpos[ $c['nick'] ]) . '" bubble="' . $bubbleN . '" ' .
                'nick="' . misc_toAttribute($c['nick']) . '">' .
                misc_toXml($c['line']) . '</chatline>';
    }

    for ($i = 1; $i <= $g_bubble_max; $i++)
    {
        if (!$arr_taken_bubble[$i])
        {
            echo '<chatline position="0" bubble="' . $i . '" ' .
                   'nick="" />';
        }
    }
}

function getBotName($room)
{
    $name = '';
    $query = "SELECT nick FROM chat_chair " .
            "WHERE room = " . smartQuote($room) . " AND bot = 1 LIMIT 1";
    $rows = mysql_query($query) or die( "GetBotName Error: " . mysql_error() );
    while ( $c = mysql_fetch_array($rows) )
    {
        $name = $c['nick'];
    }

    return $name;
}

function addLine($nick, $fingerprint, $line, $room)
{
    global $g_suborder;

    $g_suborder++;
    $query = "INSERT INTO chat_line (nick, fingerprint, line, timesaid, room, suborder) " .
            "VALUES (" . smartQuote($nick) . ", " . smartQuote($fingerprint) . ", "  . smartQuote($line) . ", " . smartQuote( getIsoDate() ) . ", " . smartQuote($room) . ", " . smartQuote($g_suborder) . ")";
    $rows = mysql_query($query) or die( "AddLine Error: " . mysql_error() );
}

function handleBot($nick, $line, $room)
{
    global $g_botName;
    global $g_roomTitle;

    $line = trim($line);
    $line = strtolower($line);
    $newline = str_replace('!google', '', $line);
    $newline = trim($newline);

    if ($newline != $line)
    {
        if ( trim($newline) != '')
        {
            $sLink = getTopLink($newline);
            addLine($g_botName, '', ucfirst($nick) . ', I googled ' . $newline . ': ' . $sLink, $room);
        }
        else
        {
            addLine($g_botName, '', ucfirst($nick) . ', what do you want me to find? Type !google something...', $room);
        }
    }

    $newline = str_replace( strtolower($g_botName), '', $line );
    if ($newline != $line)
    {
        $say = '';
        if ( instr($newline, 'how are you') ) {
            $say = "I'm fine, except my battery life is nearing its end.";
        }
        else if ( instr($newline, 'time') || instr($newline, 'date') ) {
            $say = "My internal clock says it's " . date("F j, Y, g:i a") . ".";
        }
        else if ( instr($newline, 'your name') || instr($newline, 'who are you') || instr($newline, 'what are you') ) {
            $say = "Just call me " . $g_botName . ". Or The Big G.";
        }
        else if ( instr($newline, 'bye') || instr($newline, 'good night') ) {
            $say = "Bye bye, " . ucfirst($nick) . ".";
        }
        else if ( instr($newline, 'birthday') ) {
            $say = "1789.";
        }
        else if ( instr($newline, 'hello') ) {
            $say = "Hello, " . ucfirst($nick) . ".";
        }
        else if ( instr($newline, 'where') ) {
            $say = "My geo-location is broken so I can't answer that.";
        }
        else if ( instr($newline, 'planet') ) {
            $say = "I once spent holidays on Magrathea.";
        }
        else if ( instr($newline, 'dumb') || instr($newline, 'stupid') || instr($newline, 'poop') ) {
            $say = "Never pick a fight with a robot.";
        }
        else if ( instr($newline, 'answer to life') ) {
            $say = "42.";
        }
        else if ( instr($newline, 'inventor') ) {
            $say = "Philipp Lenssen invented me. You can reach him at philipp.lenssen@gmail.com";
        }
        else if ( instr($newline, 'favorite color') ) {
            $say = "Metallic blue.";
        }
        else if ( instr($newline, 'help') ) {
            $say = "If you need help mail my inventor Philipp Lenssen at philipp.lenssen@gmail.com";
        }
        else if ( instr($newline, 'how old') || instr($newline, 'your age') || instr($newline, 'your birthday') ) {
            $say = "I'm around 400 years old. And you?";
        }
        else if ( rand(1,100) >= 50 ) {
            $say = getRandomQuote();
        }

        if ($say != '')
        {
            $say = str_replace("'", "''", $say);
            addLine($g_botName, '', $say, $room);
        }
    }

    if ($line == '[entered room.]')
    {
        addLine($g_botName, '', 'Welcome to the ' . $g_roomTitle . ', ' . ucfirst($nick) . '.' , $room);
    }

    handleTrivia($nick, $line);
}

function instr($haystack, $needle)
{
    return !( strpos($haystack, $needle) === false );
}

function getTopLink($q)
{
    $ret = '';
    error_reporting(E_ERROR | E_PARSE);
    $dom = new domdocument;
    $dom->loadHTMLFile('http://www.google.com/search?hl=en&q=' . urlencode($q) . '&num=1');
    $xpath = new domxpath($dom);
    $s = $xpath->query("//p/a[@href]")->item(0)->getAttribute('href');
    if ( ! ( strpos($s, 'spell=1') === false ) )
    {
        $s = $xpath->query("//p/a[@href]")->item(1)->getAttribute('href');
    }
    $ret = ( strpos($s, '/search?') === false ) ? $s : 'No match.';
    return $ret;
}

function getRandomQuote()
{
    $quotes = file('quotes.dat');
    $r = rand(0, count($quotes) - 1);
    $s = $quotes[$r];
    $s = str_replace("\r\n", '', $s);
    $s = str_replace("\r", '', $s);
    $s = str_replace("\n", '', $s);
    return $s;
}

?>